package com.gct.diagnose.algorithm;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * @author xusirui 2021/6/16
 */
//峰值间隔算法
public class PeakValue {

    //默认参数重载
    public double[][] findPeakValue(double[][] data, int startPoint, int endPoint, int weight) {
        return findPeakValue(data, startPoint, endPoint, weight, 1);
    }

    //默认参数重载
    public double[][] findPeakValue(double[][] data, int startPoint, int endPoint) {
        return findPeakValue(data, startPoint, endPoint, 1, 1);
    }

    /**
     * @param ex 负值法取波谷
     */
    public double[][] findPeakValue(double[][] data, int startPoint, int endPoint, int weight, int ex) {
        List<double[]> r = new ArrayList<>();
        for (int i = startPoint; i < endPoint && i < data.length; i++) {
            if (i - weight < 0 || i + weight >= data.length) continue;
            boolean isPeak = true;
            for (int j = 1; j <= weight; j++) {
                isPeak = data[i][0] > data[i - j][0]
                        && data[i][0] <= data[i + j][0]
                        && ex * data[i][1] > ex * data[i - j][1]
                        && ex * data[i][1] > ex * data[i + j][1];
                if (!isPeak) break;
            }
            if (isPeak) {
                r.add(data[i]);
            }
        }
        return r.toArray(new double[][]{});
    }

    //计算标准差
    public double cStandardDeviation(double[] values){
        double aveValue = Arrays.stream(values).average().getAsDouble();
        double res = 0;
        for (int i=0;i<values.length;i++){
            res += (values[i]-aveValue)*(values[i]-aveValue);
        }
        res/=values.length;
        return Math.sqrt(res);
    }
}
