package com.gct.diagnose.algorithm;

import com.alibaba.fastjson.JSONObject;

import java.util.HashMap;
import java.util.Map;

/**
 * @author xusirui 2021/6/16
 */
//错误功图判断
// todo: 测试正确性 -- 初步测试正确，功图样例*1
public class ProblemA {

    public boolean findProACard(double[][] gt, int prdcIsLegal) {
        return findProACard(gt, prdcIsLegal, 0.001);
    }

    /**
     * @param gt          功图
     * @param prdcIsLegal 功图是否合法 （数据库字段）
     * @param n           有需要判断冲次的 冲次异常也属于功图异常
     * @return
     */
    public boolean findProACard(double[][] gt, int prdcIsLegal, double n) {
        if (prdcIsLegal == 1) return false;
        if (n <= 0.0 || n > 10.0) return true;
        int q[] = new int[6];
        q[0] = q[1] = q[2] = q[3] = q[4] = q[5] = 0;
        if (gt == null || gt.length < 5) return false;
        double maxF = gt[0][1];
        double minF = gt[0][1];
        double maxS = gt[0][0];
        double minS = gt[0][0];

        for (int i = 0; i < gt.length; i++) {
            if (maxF < gt[i][1]) maxF = gt[i][1];
            if (minF > gt[i][1]) minF = gt[i][1];
            if (maxS < gt[i][0]) maxS = gt[i][0];
            if (maxS > gt[i][0]) minS = gt[i][0];
        }
        if (minF < 0 || minS < -0.5) return true;
        if (maxF == minF || maxS == minS) return true;

        for (int i = 0; i < gt.length - 1; i++) {
            if (gt[i][1] < 0.2) q[2]++;
            if (gt[i][0] == 0) q[0]++;
            if (Math.abs(gt[i][1] - gt[i + 1][1]) / (maxF - minF) > 0.7) q[3]++;
            if (Math.abs(gt[i][0] - gt[i + 1][0]) / (maxS - minS) > 0.5) q[4]++;
        }

        for (int i = 1; i < gt.length; i++) {
            if (gt[i][0] < maxS * 0.15 || gt[i][0] > maxS * 0.9 || gt[i][0] <= gt[i - 1][0]) continue;
            for (int j = gt.length - 1; j > 0; j--) {
                if (gt[j][0] > gt[i][0]) {
                    if (j == gt.length - 1) {
                        if (gt[i][1] + 1 < gt[j][1]) q[5]++;
                        break;
                    }
                    if (gt[j][1] >= gt[i][1] + 1 || gt[j + 1][1] >= gt[i][1] + 1) q[5]++;
                    break;
                }
            }
        }
        System.out.println(q[0]+","+q[2]+","+q[3]+","+q[4]+","+q[5]);
        if (q[5] > 0) return true;
        if (q[2] >= 10 || q[3] > 5 || q[4] > 5 || q[0] * 100 / gt.length > 80) return true;
        return (q[2] > 0 || q[3] > 0 || q[4] > 0) && prdcIsLegal == 0;
    }

    //方法二 判断功图是否正常
    public Map<String, Object> findProACardL(double[][] gt) {
        return findProACardL(gt, 0.001);
    }

    /**
     * @param gt 功图
     * @param n  有需要判断冲次的 冲次异常也属于功图异常
     * @return remark,result
     */
    public Map<String,Object> findProACardL(double[][] gt, double n) {
        HashMap<String, Object> resMap = new HashMap<>();
        resMap.put("result",0);
        resMap.put("remark","");
        if (gt == null || gt.length < 10) {
            resMap.put("remark","功图点数不足10");
            return resMap;
        }
        if (n <= 0 || n > 10) {
            resMap.put("remark","冲次异常");
            return resMap;
        }
        int[] q = new int[3];
        q[0] = q[1] = q[2] = 0;
        int protectPointNum = (int) (gt.length / 2 * 0.1);
        if (protectPointNum < 1) protectPointNum = 1;
        for (int i = 0; i < protectPointNum; i++) {
            if (gt[i][0] == 0) q[0]++;
            if (gt[i][1] < 0.2) q[2]++;
            if (gt[gt.length / 2 - i][0] == 0) q[0]++;
            if (gt[gt.length / 2 - i][1] < 0.2) q[2]++;
            if (gt[gt.length - 1 - i][0] == 0) q[0]++;
            if (gt[gt.length - 1 - i][1] < 0.2) q[2]++;
            if (i != 0) {
                if (gt[gt.length / 2 + i][0] == 0) q[0]++;
                if (gt[gt.length / 2 + i][1] < 0.2) q[2]++;
            }
        }
        int entryInfo = 1;
        for (int i = protectPointNum; i <= gt.length / 2 - protectPointNum; i++) {
            if (gt[i][0] == 0) q[0]++;
            if (gt[i][1] < 0.2) q[2]++;
            for (int j = gt.length - 1 - 1 - protectPointNum; j >= gt.length / 2 + protectPointNum; j--) {
                if (sideIntersectSide(gt[i][0], gt[i][1], gt[i + 1][0], gt[i + 1][1], gt[j][0], gt[j][1], gt[j + 1][0], gt[j + 1][1]))
                {
                    resMap.put("remark","功图存在相交区域");
                    return resMap;
                }
                if (entryInfo == 1) {
                    if (j == gt.length / 2 + protectPointNum) entryInfo = 0;
                    if (gt[j][0] == 0) q[0]++;
                    if (gt[j][1] < 0.2) q[2]++;
                }
            }
        }
        if (q[2] > 10 || q[0] * 1.0 / gt.length > 0.8){
            resMap.put("remark","非法值过多");
        }else {
            resMap.put("result",1);
            resMap.put("remark","功图合法");
        }
        return resMap;
    }

    private boolean predictGTPointByRealInter(double[] x, double[] y, double xT, double yT) {
        CurveFitting curveFitting = new CurveFitting();
        double[] fit = curveFitting.multiLine(x, y, x.length, 3);
        double tY = curveFitting.computY(xT, fit);
        return Math.abs(tY - yT) > tY * 0.6;
    }

    private boolean lineIntersectSide(double aX, double aY, double bX, double bY, double cX, double cY, double dX, double dY) {
        double fC = (cY - aY) * (aX - bX) - (cX - aX) * (aY - bY);
        double fD = (dY - aY) * (aX - bX) - (dX - aX) * (aY - bY);
        return fC * fD < 0;
    }


    private boolean sideIntersectSide(double aX, double aY, double bX, double bY, double cX, double cY, double dX, double dY) {
        if (!lineIntersectSide(aX, aY, bX, bY, cX, cY, dX, dY)) return false;
        if (!lineIntersectSide(cX, cY, dX, dY, aX, aY, bX, bY)) return false;
        return true;
    }


    /*public static void main(String[] args) {
        String sgtStr = "[[0.0, 100.76], [0.0, 300.08], [0.01, 200.56], [0.03, 43.04], [0.06, 44.16], [0.09, 44.96], [0.12, 45.76], [0.17, 47.68], [0.21, 48.64], [0.25, 49.12], [0.32, 48.64], [0.38, 47.84], [0.43, 47.04], [0.52, 45.6], [0.59, 44.96], [0.66, 44.8], [0.73, 44.96], [0.84, 46.08], [0.92, 46.88], [1.0, 47.36], [1.12, 48.16], [1.21, 48.16], [1.29, 48.0], [1.43, 47.04], [1.52, 46.4], [1.61, 45.92], [1.75, 45.6], [1.85, 45.6], [1.94, 45.76], [2.04, 45.92], [2.18, 46.4], [2.27, 46.56], [2.37, 46.56], [2.51, 46.4], [2.6, 46.24], [2.69, 45.92], [2.83, 45.12], [2.92, 44.8], [3.0, 44.64], [3.13, 44.32], [3.21, 44.32], [3.29, 44.48], [3.37, 44.48], [3.48, 44.32], [3.55, 44.0], [3.62, 43.68], [3.71, 43.04], [3.77, 42.56], [3.83, 42.08], [3.9, 41.28], [3.95, 41.12], [3.99, 40.96], [4.05, 40.64], [4.08, 40.64], [4.11, 40.47], [4.14, 40.64], [4.16, 40.64], [4.18, 40.47], [4.19, 40.47], [4.19, 40.32], [4.19, 40.15], [4.19, 39.68], [4.17, 39.04], [4.16, 38.56], [4.14, 37.92], [4.1, 36.0], [4.07, 35.36], [4.03, 35.04], [3.99, 35.2], [3.93, 35.84], [3.88, 36.47], [3.83, 37.11], [3.74, 38.24], [3.68, 38.08], [3.62, 37.76], [3.52, 36.79], [3.45, 36.15], [3.37, 35.68], [3.26, 35.04], [3.17, 35.2], [3.09, 35.36], [3.01, 35.84], [2.88, 36.47], [2.79, 36.64], [2.7, 36.64], [2.56, 36.47], [2.47, 36.0], [2.37, 35.68], [2.23, 35.2], [2.13, 35.04], [2.04, 35.04], [1.9, 35.36], [1.8, 35.68], [1.71, 36.0], [1.61, 36.15], [1.48, 36.47], [1.39, 36.47], [1.3, 36.32], [1.17, 36.15], [1.08, 36.15], [1.0, 36.15], [0.88, 36.32], [0.8, 36.64], [0.73, 36.96], [0.63, 37.6], [0.56, 37.92], [0.5, 38.08], [0.44, 38.4], [0.35, 38.56], [0.3, 38.56], [0.25, 38.72], [0.19, 39.04], [0.15, 39.2], [0.12, 39.52], [0.07, 40.15], [0.05, 40.47], [0.03, 40.64], [0.01, 40.96], [0.0, 41.12], [0.0, 41.12]]";
        double[][] sgt = JSONObject.parseObject(sgtStr, double[][].class);
        ProblemA problemA = new ProblemA();
        System.out.println(problemA.findProACard(sgt,0));
    }*/
}
