package com.gct.diagnose.controller;


import com.gct.common.core.result.Result;
import com.gct.diagnose.entity.Vo.GetInfoByIdVo;
import com.gct.diagnose.service.DgnsGtfeaturesService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author 王森玉
 * @since 2021-01-28
 */

@Api(value = "Dgns_gtfeaturesController", description = "功图特征库")
@RestController
@RequestMapping("/gtfeatures")
public class DgnsGtfeaturesController {

    @Autowired
    private DgnsGtfeaturesService dgnsGtfeaturesService;

    //@PreAuthorize("hasAuthority('sys:user:modify') or hasAuthority('feign')")
    @ApiOperation(value = "分页查询", notes = "分页查询功图特征库")
    @GetMapping("/pages")
    public Result findFeaturesByPages(
            @ApiParam(name = "pageNum", value = "当前页", required = true) @RequestParam("pageNum") Integer pageNum,
            @ApiParam(name = "pageSize", value = "页大小", required = true) @RequestParam("pageSize") Integer pageSize,
            @ApiParam(name = "effect_area", value = "作用区域") @RequestParam(value = "effect_area", required = false) Integer effect_area,
            @ApiParam(name = "graphic_feature_interpretation", value = "特征类型") @RequestParam(value = "graphic_feature_interpretation", required = false) String graphic_feature_interpretation,
            @ApiParam(name = "orgid", value = "作业区Id") @RequestParam(value = "orgid", required = false) String orgid,
            @ApiParam(name = "jh", value = "井号") @RequestParam(value = "jh", required = false) String jh
    ) {
        Map<String, Object> featuresByPages = dgnsGtfeaturesService.findFeaturesByPages(pageNum, pageSize, effect_area, graphic_feature_interpretation, orgid, jh);
        return Result.ok(featuresByPages);
    }

    /*@ApiOperation(value = "工况分类管理",notes = "工况分类管理")
    @GetMapping("/workingConditionManagement")
    public Result workingConditionManagementControl(){
        return Result.ok(dgns_gtfeaturesService.workingConditionManagement());
    }*/
    @ApiOperation(value = "功图特征库按ID搜索", notes = "功图特征库按ID搜索--分页")
    @PostMapping("/getFeaturesInfoByIDPages")
    public Result getInfoByIDPages(@RequestBody GetInfoByIdVo getInfoByIdVo) {
        return Result.ok(dgnsGtfeaturesService.getInfoByIDPages(getInfoByIdVo.getId(), getInfoByIdVo.getPage(), getInfoByIdVo.getSize()));
    }

    /*@ApiOperation(value = "获取默认特征功图数据（全部数据）",notes = "进入特征库管理时调用")
    @GetMapping("/getDefaultFeatures")
    public Result getDefaultFeatures()*/

}



