package com.gct.diagnose.controller;


import com.alibaba.fastjson.JSONObject;
import com.gct.common.core.result.Result;
import com.gct.diagnose.entity.DgnsGtgktype;
import com.gct.diagnose.service.DgnsGtgktypeService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author 王森玉
 * @since 2021-01-28
 */

@Api(value = "Dgns_gtgktypeController", description = "特征类型")
@RestController
@RequestMapping("/getGktype")
public class DgnsGtgktypeController {
    @Autowired
    DgnsGtgktypeService dgnsGtgktypeService;

    @ApiOperation(value = "getArea(获取特征类型数据)", notes = "获取特征类型数据")
    @GetMapping("/type")
    public Result findGtgktype() {
        return dgnsGtgktypeService.findGtgktype();
    }


    @GetMapping("/getAllGtCardLibCount")
    public Result getAllGtCardLibCount(Integer curPage, Integer pageSize) {
        JSONObject jo = dgnsGtgktypeService.getAllGtCardLibCount(curPage, pageSize);
        return Result.ok(jo);
    }

    @PostMapping("/addGtGkType")
    public Result addGtGkType(@RequestBody DgnsGtgktype dgnsGtgktype) {
        boolean isSuccess = dgnsGtgktypeService.addGtGkType(dgnsGtgktype);
        return isSuccess ? Result.ok("添加成功") : Result.error("添加失败，该特征已存在");
    }

    @GetMapping("/deleteGtGkType")
    public Result deleteGtGkType(@RequestParam Integer id) {
        boolean isSuccess = dgnsGtgktypeService.deleteGtGkType(id);
        return isSuccess ? Result.ok("删除成功") : Result.error("删除失败");
    }

    @GetMapping("/getGtGkTypeById")
    public Result getGtGkTypeById(@RequestParam Integer id) {
        DgnsGtgktype dgnsGtgktype = dgnsGtgktypeService.getGtGkTypeById(id);
        return Result.ok(dgnsGtgktype);
    }

    @PostMapping("/updateGtGkType")
    public Result updateGtGkType(@RequestBody DgnsGtgktype dgnsGtgktype) {
        boolean isSuccess = dgnsGtgktypeService.updateGtGkType(dgnsGtgktype);
        return isSuccess ? Result.ok("更新成功") : Result.error("更新失败,特征名已存在");
    }


}



