package com.gct.diagnose.controller;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gct.common.core.result.Result;
import com.gct.diagnose.entity.DgnsGtmeasure;
import com.gct.diagnose.entity.DgnsGtmeasureInfo;
import com.gct.diagnose.service.DgnsGtmeasureInfoService;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;


/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xsr
 * @since 2021-05-12
 */
@RestController
@RequestMapping("/measure")
public class DgnsGtmeasureInfoController {

    @Autowired
    DgnsGtmeasureInfoService dgnsGtmeasureInfoService;

    @GetMapping("/getAllMeasureInfo")
    public Result getAllMeasureInfo(@ApiParam("组织Id")@RequestParam String orgId, @ApiParam("组织层级")@RequestParam Integer level, @ApiParam("井号")@RequestParam String wellId,
                                    @ApiParam("开始时间")@RequestParam String beginDate, @ApiParam("结束时间")@RequestParam String endDate, @ApiParam("措施类型")@RequestParam String category,
                                    @ApiParam("措施状态")@RequestParam String status, @ApiParam("进度")@RequestParam String schedule, @ApiParam("页码")@RequestParam Integer curPage,
                                    @ApiParam("页面大小")@RequestParam Integer pageSize){
        JSONObject ja = dgnsGtmeasureInfoService.getAllMeasureInfo(orgId,level,wellId,beginDate,endDate,category,status,schedule,curPage,pageSize);
        return ja.getJSONArray("data").size()==0?Result.error("无数据"):Result.ok(ja);
    }

    @GetMapping("/getMeasureInfoCount")
    public Result getMeasureInfoCount(@ApiParam("开始时间")@RequestParam String beginDate,@ApiParam("结束时间")@RequestParam String endDate,
                                      @ApiParam("组织Id")@RequestParam String orgId
    ){
        JSONArray ja = dgnsGtmeasureInfoService.getMeasureInfoCount(beginDate,endDate,orgId);
        return ja.size()==0?Result.error("无数据"):Result.ok(ja);
    }

    @GetMapping("/updateMeasureInfo")
    public Result updateMeasureInfo(@ApiParam("措施信息")DgnsGtmeasureInfo dgnsGtmeasureInfo){
        Integer res = dgnsGtmeasureInfoService.updateMeasureInfo(dgnsGtmeasureInfo);
        return res>0?Result.ok("成功"):Result.error("失败");
    }

    //Feign
    @GetMapping("/getAllMeasureInfoAnalysis")
    public Result getAllMeasureInfoAnalysis(@RequestParam String beginDate, @RequestParam String endDate, @RequestParam String wellDataCount) {
        JSONArray ja = dgnsGtmeasureInfoService.getAllMeasureInfoAnalysis(beginDate,endDate,wellDataCount);
        return Result.ok(ja);
    }

}

