package com.gct.diagnose.controller;


import com.gct.common.core.result.Result;
import com.gct.diagnose.entity.DgnsGtstandardSetting;
import com.gct.diagnose.entity.Vo.GetInfoByIdVo;
import com.gct.diagnose.entity.Vo.GstStandarSettingVo;
import com.gct.diagnose.service.DgnsGtstandardSettingService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * <p>
 *  标准功图设置前端控制器
 * </p>
 *
 * @author NewMeanning
 * @since 2021-02-03
 */
@RestController
@RequestMapping("/dgnsGtstandardSetting")
@Api(value = "DgnsGtstandardSettingController",description = "标准功图设置")
public class DgnsGtstandardSettingController {

    @Autowired
    private DgnsGtstandardSettingService dgnsGtstandardSettingService;

    @ApiOperation(value = "设置", notes = "设置标准功图")
    @PostMapping
    public Result setting(@RequestBody DgnsGtstandardSetting dgnsGtstandardSetting){
        return dgnsGtstandardSettingService.setting(dgnsGtstandardSetting);
    }

    @ApiOperation(value = "设置信息", notes = "标准功图设置信息")
    @GetMapping
    public Result info(){
        return dgnsGtstandardSettingService.getSettingInfo();
    }


    @ApiOperation(value = "标准功图库按照条件搜索",notes = "标准功图库按照条件搜索")
    @PostMapping("/getGtstandardSettingInfoPages")
    public Result getGtstandardSettingInfoPages(@RequestBody GstStandarSettingVo gstStandarSettingVo){
        Map<String, Object> data = dgnsGtstandardSettingService.getGtstandardSettingInfoPages(gstStandarSettingVo);
        return Result.ok(data);
    }
    @ApiOperation(value = "标准功图按ID搜索",notes = "标准功图按ID搜索--分页")
    @PostMapping("/getStandArdInfoByIDPages")
    public Result getInfoByIDPages(@RequestBody GetInfoByIdVo getInfoByIdVo){
        return Result.ok(dgnsGtstandardSettingService.getInfoByIDPages(getInfoByIdVo.getId(),getInfoByIdVo.getPage(),getInfoByIdVo.getSize()));
    }
}

