package com.gct.diagnose.decisiontree.DataLoadTemplates;

import com.alibaba.fastjson.JSONObject;
import com.gct.common.core.result.Result;
import com.gct.diagnose.decisiontree.DependentDataConstructor;
import com.gct.diagnose.decisiontree.DependentDataFieldEnum;
import com.gct.diagnose.entity.WellStatusDailyData;
import com.gct.diagnose.feignclient.BaseDataClient;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Map;

@DependentDataConstructor.DependentDataLoad(Name = "GD")
public class GDSimilarGtAlgorithmDataLoad implements DependentDataConstructor.IDependentDataLoad {

    @Autowired
    BaseDataClient baseDataClient;

    @Override
    public void loadData(Map<String, Object> gdMap) {
        String statusDailyStr = baseDataClient.getWellBoreStatusDaily(gdMap.get(DependentDataFieldEnum.JH.getEnDec()).toString(), gdMap.get("curGtTime").toString());
        Result<WellStatusDailyData> result = JSONObject.parseObject(statusDailyStr, Result.class);
        WellStatusDailyData wellStatusDailyData = null;
        try {
            if(result!=null)wellStatusDailyData = result.toFiguredOutObject(WellStatusDailyData.class);
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (wellStatusDailyData != null) {
            gdMap.put(DependentDataFieldEnum.DYM.getEnDec(), wellStatusDailyData.getStartPumpLiqLevel());
            gdMap.put(DependentDataFieldEnum.BS.getEnDec(), wellStatusDailyData.getPumpDepth());
            if (wellStatusDailyData.getStartPumpLiqLevel() != null && wellStatusDailyData.getPumpDepth() != null) {
                gdMap.put(DependentDataFieldEnum.CMD.getEnDec(),
                        wellStatusDailyData.getPumpDepth() - wellStatusDailyData.getStartPumpLiqLevel());
            } else {
                gdMap.put(DependentDataFieldEnum.CMD.getEnDec(), null);
            }
            gdMap.put(DependentDataFieldEnum.BJ.getEnDec(), wellStatusDailyData.getOilNozzle());
        } else {
            gdMap.put(DependentDataFieldEnum.DYM.getEnDec(), null);
            gdMap.put(DependentDataFieldEnum.BS.getEnDec(), null);
            gdMap.put(DependentDataFieldEnum.CMD.getEnDec(), null);
            gdMap.put(DependentDataFieldEnum.BJ.getEnDec(), null);
        }

        wellStatusDailyData = null;
        if (gdMap.get(DependentDataFieldEnum.BZSJ.getEnDec()) != null) {
            String standardWellBoreStatusDaily = baseDataClient.getWellBoreStatusDaily(gdMap.get(DependentDataFieldEnum.JH.getEnDec()).toString(), gdMap.get(DependentDataFieldEnum.BZSJ.getEnDec()).toString());
            result = JSONObject.parseObject(standardWellBoreStatusDaily, Result.class);
            try {
               if(result!=null) wellStatusDailyData = result.toFiguredOutObject(WellStatusDailyData.class);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        if (wellStatusDailyData != null) {
            gdMap.put(DependentDataFieldEnum.BZDYM.getEnDec(), wellStatusDailyData.getStartPumpLiqLevel());
            gdMap.put(DependentDataFieldEnum.BZBS.getEnDec(), wellStatusDailyData.getPumpDepth());
            if (wellStatusDailyData.getStartPumpLiqLevel() != null && wellStatusDailyData.getPumpDepth() != null) {
                gdMap.put(DependentDataFieldEnum.BZCMD.getEnDec(),
                        wellStatusDailyData.getPumpDepth() - wellStatusDailyData.getStartPumpLiqLevel());
            } else {
                gdMap.put(DependentDataFieldEnum.BZCMD.getEnDec(), null);
            }
            gdMap.put(DependentDataFieldEnum.BZBJ.getEnDec(), wellStatusDailyData.getOilNozzle());
        } else {
            gdMap.put(DependentDataFieldEnum.BZDYM.getEnDec(), null);
            gdMap.put(DependentDataFieldEnum.BZBS.getEnDec(), null);
            gdMap.put(DependentDataFieldEnum.BZCMD.getEnDec(), null);
            gdMap.put(DependentDataFieldEnum.BZBJ.getEnDec(), null);
        }

    }
}
