package com.gct.diagnose.decisiontree.DataLoadTemplates;

import com.alibaba.fastjson.JSONObject;
import com.gct.common.core.result.Result;
import com.gct.diagnose.decisiontree.DependentDataConstructor;
import com.gct.diagnose.decisiontree.DependentDataFieldEnum;
import com.gct.diagnose.entity.WellVolDailyData;
import com.gct.diagnose.feignclient.BaseDataClient;
import org.springframework.beans.factory.annotation.Autowired;

import java.lang.reflect.InvocationTargetException;
import java.util.Map;

@DependentDataConstructor.DependentDataLoad(Name = "SYTS")
public class SYTSJudgeAlgorithmDataLoad implements DependentDataConstructor.IDependentDataLoad {

    @Autowired
    BaseDataClient baseDataClient;

    @Override
    public void loadData(Map<String, Object> gdMap) {
        String curWellBoreVolDaily = baseDataClient.getWellBoreVolDaily(gdMap.get(DependentDataFieldEnum.JH.getEnDec()).toString(), gdMap.get("curGtTime").toString());
        Result<WellVolDailyData> result = JSONObject.parseObject(curWellBoreVolDaily, Result.class);
        WellVolDailyData curWellVolDailyData = null;
        try {
            curWellVolDailyData = result.toFiguredOutObject(WellVolDailyData.class);
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (curWellVolDailyData == null) curWellVolDailyData = new WellVolDailyData();
        gdMap.put(DependentDataFieldEnum.HSL.getEnDec(), curWellVolDailyData.getWaterCut());
        //
        gdMap.put(DependentDataFieldEnum.RCY.getEnDec(), curWellVolDailyData.getOilProdDaily());
        gdMap.put(DependentDataFieldEnum.RCYe.getEnDec(), curWellVolDailyData.getLiqProdDaily());
        if (gdMap.get(DependentDataFieldEnum.BZSJ.getEnDec()) != null) {
            String standardWellBoreVolDaily = baseDataClient.getWellBoreVolDaily(gdMap.get(DependentDataFieldEnum.JH.getEnDec()).toString(), gdMap.get(DependentDataFieldEnum.BZSJ.getEnDec()).toString());
            result = JSONObject.parseObject(standardWellBoreVolDaily, Result.class);
            WellVolDailyData standardWellVolDailyData = null;
            try {
                standardWellVolDailyData = result.toFiguredOutObject(WellVolDailyData.class);
            } catch (Exception e) {
                e.printStackTrace();
            }
            if (standardWellVolDailyData == null) standardWellVolDailyData = new WellVolDailyData();
            gdMap.put(DependentDataFieldEnum.BZHSL.getEnDec(), standardWellVolDailyData.getWaterCut());
            //
            gdMap.put(DependentDataFieldEnum.BZRCY.getEnDec(), standardWellVolDailyData.getOilProdDaily());
            gdMap.put(DependentDataFieldEnum.BZRCYe.getEnDec(), standardWellVolDailyData.getLiqProdDaily());
        } else {
            gdMap.put(DependentDataFieldEnum.BZHSL.getEnDec(), null);
            //
            gdMap.put(DependentDataFieldEnum.BZRCY.getEnDec(), null);
            gdMap.put(DependentDataFieldEnum.BZRCYe.getEnDec(), null);
        }
    }
}
