package com.gct.diagnose.decisiontree.DataLoadTemplates;


import com.gct.common.util.SGTUtil;
import com.gct.diagnose.decisiontree.DependentDataConstructor;
import com.gct.diagnose.decisiontree.DependentDataFieldEnum;
import com.gct.diagnose.entity.DgnsGtbaseparam;
import com.gct.diagnose.feignclient.BaseDataClient;
import com.gct.diagnose.service.DgnsGtbaseparamService;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Map;

/**
 * class name: SampleDataLoad
 * <p>
 * 用于扩展 DependentDataConstructor 加载的 类
 * 此类需实现 IDependentDataLoad 接口 并仿照下面的进行编辑
 * </p>
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/1/25 下午10:02
 */
@DependentDataConstructor.DependentDataLoad(Name = "Sample")
public class SampleDataLoad implements DependentDataConstructor.IDependentDataLoad {

    @Autowired
    DgnsGtbaseparamService dgnsGtbaseparamService;

    @Autowired
    BaseDataClient baseDataClient;

    @Override
    public void loadData(Map<String, Object> gdMap) {
        gdMap.put(DependentDataFieldEnum.LOG.getEnDec(), "");
        DgnsGtbaseparam curGt = (DgnsGtbaseparam) gdMap.get("dgnsGtbaseparam");
        gdMap.put(DependentDataFieldEnum.YXCC.getEnDec(), curGt.getSEffect());
        gdMap.put(DependentDataFieldEnum.ZDZH.getEnDec(), curGt.getLMax());
        gdMap.put(DependentDataFieldEnum.ZHC.getEnDec(), curGt.getL());
        gdMap.put(DependentDataFieldEnum.ZXZH.getEnDec(), curGt.getLMin());
        gdMap.put(DependentDataFieldEnum.MJ.getEnDec(), curGt.getArea());
        gdMap.put(DependentDataFieldEnum.DYXXZHGD.getEnDec(), curGt.getLFirstdownturnpoint());
        gdMap.put(DependentDataFieldEnum.CC.getEnDec(), curGt.getS());
        gdMap.put(DependentDataFieldEnum.ZDCC.getEnDec(), curGt.getSMax());
        gdMap.put(DependentDataFieldEnum.CCi.getEnDec(), curGt.getN());

        if (gdMap.get(DependentDataFieldEnum.BZSJ.getEnDec()) != null) {
            DgnsGtbaseparam standardGt = dgnsGtbaseparamService.getByWellIdAndProdDate(
                    gdMap.get(DependentDataFieldEnum.JH.getEnDec()).toString(), gdMap.get(DependentDataFieldEnum.BZSJ.getEnDec()).toString());
            gdMap.put(DependentDataFieldEnum.BZGT.getEnDec(), SGTUtil.encodeToUseList(standardGt.getSgt()));
            gdMap.put(DependentDataFieldEnum.BZSJ.getEnDec(), standardGt.getProdDateStr());
            gdMap.put(DependentDataFieldEnum.BZZDZH.getEnDec(), standardGt.getLMax());
            gdMap.put(DependentDataFieldEnum.BZZHC.getEnDec(), standardGt.getL());
            gdMap.put(DependentDataFieldEnum.BZMJ.getEnDec(), standardGt.getArea());
            gdMap.put(DependentDataFieldEnum.BZZHZX.getEnDec(), standardGt.getLMid());
            gdMap.put(DependentDataFieldEnum.BZZXZH.getEnDec(), standardGt.getLMin());
            gdMap.put(DependentDataFieldEnum.BZDYXXZHGD.getEnDec(), standardGt.getLFirstdownturnpoint());
            gdMap.put(DependentDataFieldEnum.BZCC.getEnDec(), standardGt.getS());
            gdMap.put(DependentDataFieldEnum.BZCCi.getEnDec(), standardGt.getN());
        } else {
            gdMap.put(DependentDataFieldEnum.BZGT.getEnDec(), null);
            gdMap.put(DependentDataFieldEnum.BZSJ.getEnDec(), null);
            gdMap.put(DependentDataFieldEnum.BZZDZH.getEnDec(), null);
            gdMap.put(DependentDataFieldEnum.BZZHC.getEnDec(), null);
            gdMap.put(DependentDataFieldEnum.BZMJ.getEnDec(), null);
            gdMap.put(DependentDataFieldEnum.BZZHZX.getEnDec(), null);
            gdMap.put(DependentDataFieldEnum.BZZXZH.getEnDec(), null);
            gdMap.put(DependentDataFieldEnum.BZDYXXZHGD.getEnDec(), null);
            gdMap.put(DependentDataFieldEnum.BZCC.getEnDec(), null);
            gdMap.put(DependentDataFieldEnum.BZCCi.getEnDec(), null);
        }

    }
}
