package com.gct.diagnose.decisiontree;

import com.alibaba.fastjson.JSONObject;
import com.gct.diagnose.feignclient.BaseDataClient;
import lombok.extern.slf4j.Slf4j;
import lombok.val;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import java.lang.annotation.*;
import java.util.HashMap;
import java.util.IdentityHashMap;
import java.util.Map;

/**
 * class name: DependentDataConstructor
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/1/23 下午2:47
 */
@Component
@Scope("prototype")
@Slf4j
public class DependentDataConstructor {

    private Map<String, Object> globeData = new HashMap<>();

    private BaseDataClient baseDataClient;


    public DependentDataConstructor() {
        /*try {
            defaultLoadGlobeData();
        } catch (NoSuchFieldException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }*/
    }

    //    @Autowired
    public DependentDataConstructor(BaseDataClient baseDataClient) {
        this.baseDataClient = baseDataClient;
        /*try {
            defaultLoadGlobeData();
        } catch (NoSuchFieldException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        }*/
    }

    public void loadGlobeData(String initArgs[]) {
        /*globeData.put(DependentDataFieldEnum.JH.getDec(), initArgs[0]);
        globeData.put(DependentDataFieldEnum.XSD.getDec(), initArgs[1]);*/
    }

    public void defaultLoadGlobeData(Map<String,Object>initMap) throws NoSuchFieldException, IllegalAccessException {
        initMap.forEach((x,y)->globeData.put(x,y));

        //TODO:此处接口还未测试成功 传回的值有问题
        if (baseDataClient != null) {
            String latestA2DailyDataStr = baseDataClient.getLatestA2DailyData(globeData.get("wellName").toString());
            val parse = JSONObject.parseObject(latestA2DailyDataStr, com.gct.common.core.result.Result.class);

            if (parse.getStatus() != 1)
                throw new IllegalStateException("defaultLoadGlobeData:Not get available globe data");
            /**
             *
             * TODO:此处是一个示例，需要丰富
             * globeData.put("" + DependentDataFieldEnum.DYM.getTypeID(), parse.getData().getClass().getField("dym").get(parse.getData()));
             */
        }
        //globeData.put(DependentDataFieldEnum.DYM.getEnDec(), 1000.0);
    }


    //key is not load values Description
    private void extendLoadGlobeData(String key) {

        DependentDataFieldEnum fieldEnum;
        try {
            fieldEnum = DependentDataFieldEnum.valueOf(key);
        } catch (Exception e) {
            log.error("can not found dataLoad of key {}", key);
            return;
        }
        IDependentDataLoad dataLoad = TemplateConfiguration.getDataLoadTemplateBy(fieldEnum.getTemp());
        if(dataLoad!=null)dataLoad.loadData(globeData);
    }

    @Retention(RetentionPolicy.RUNTIME)
    @Documented
    @Target(ElementType.TYPE)
    @Component
    public @interface DependentDataLoad {
        String Name() default "";
    }

    public interface IDependentDataLoad {
        void loadData(Map<String, Object> gdMap);
    }


    public Object getGlobeDataValue(String key) {
        if (!globeData.containsKey(key)){
            extendLoadGlobeData(key);
        }
        return globeData.get(key);
    }

    public void putGlobeDataValue(String key, Object val) {
        if (globeData.containsKey(key)) globeData.replace(key, val);
        else globeData.put(key, val);// to replace or insert new value
    }
}


