package com.gct.diagnose.decisiontree.MataComputeTemplates;

import com.gct.diagnose.decisiontree.ComputeTemplateProxyFactory;
import org.junit.jupiter.api.extension.ParameterResolutionException;

import javax.validation.constraints.NotNull;

/**
 * class name: MultiplicationComputeTemplate
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/1/23 下午5:06
 */
@ComputeTemplateProxyFactory.ComputeTemplate(name = "x",describe = "乘法运算模板(多参)")
public class MultiplicationComputeTemplate implements ComputeTemplateProxyFactory.IComputeTemplate {
    @Override
    public Object[] invokeCompute(@NotNull Object[] args) throws NumberFormatException{
        if (args.length < 1) throw new ParameterResolutionException("Multiplication:less than 1 param");
        double a = Double.parseDouble(args[0].toString());
        for (int i = 1; i < args.length; i++) {
            a = a * Double.parseDouble(args[i].toString());
        }
        return new Object[0];
    }
}
