package com.gct.diagnose.entity;

import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 
 * </p>
 *
 * @author xsr
 * @since 2021-04-21
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="DgnsGtcardLib对象", description="")
public class DgnsGtcardLib extends Model<DgnsGtcardLib> {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "唯一id，井号+时间")
    private String id;

    @ApiModelProperty(value = "井号")
    private String wellId;

    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss" , timezone = "GMT+8")
    private LocalDateTime proDate;

    @ApiModelProperty(value = "一共有48个特征值，特征值1")
    private String sgtcharacters;

    @ApiModelProperty(value = "示功图")
    private String indicatorDiagram;

    @ApiModelProperty(value = "诊断结果种类")
    private String result;

    @ApiModelProperty(value = "井号")
    private String jh;

    private Integer effectonjh;

    private Integer effectonqk;

    @ApiModelProperty(value = "影响全部（是否）")
    private Integer effectonall;

    @ApiModelProperty(value = "最大载荷")
    private Double maxload;

    @ApiModelProperty(value = "最小载荷")
    private Double minload;

    private Double dload;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)

    private LocalDateTime createTime;

    @ApiModelProperty(value = "诊断结果种类代号")
    private Integer code;

    @ApiModelProperty(value = "逻辑删除标志")
    @TableLogic
    private Integer deleted;

    @Override
    protected Serializable pkVal() {
        return null;
    }

    public String getProDateStr(){
        String s = this.proDate.toString();
        s = s.substring(0,10)+' '+s.substring(11);
        return s;
    }

}
