package com.gct.diagnose.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.io.Serializable;
import java.time.LocalDateTime;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 功图特征库
 * </p>
 *
 * @author wsy
 * @since 2021-01-27
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="Dgns_gtfeatures对象", description="功图特征库")
@TableName(schema = "public",value = "dgns_gtfeatures")
public class DgnsGtfeatures extends Model<DgnsGtfeatures> {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "示功图出现时间")
    private LocalDateTime sgt_prodate;

    @ApiModelProperty(value = "功图Id")
    private String id;

    @ApiModelProperty(value = "功图特征值")
    private String sgt_characters;

    @ApiModelProperty(value = "出现次数")
    private Integer appear_counter;

    @ApiModelProperty(value = "图形特征解释")
    private String graphic_feature_interpretation;

    @ApiModelProperty(value = "最大相似度")
    private float max_semblance;

    @ApiModelProperty(value = "最小相似度")
    private float min_semblance;

    @ApiModelProperty(value = "井名")
    private String well_name;

    @ApiModelProperty(value = "创建时间")
    @TableField("create_time")
    private LocalDateTime create_time;

    @ApiModelProperty(value = "最后更新时间")
    private LocalDateTime latest_updated_time;

    @ApiModelProperty(value = "示功图")
    private String sgt;

    @ApiModelProperty(value = "作用区域Id")
    private Integer effect_area;

    @Override
    protected Serializable pkVal() {
        return null;
    }

}
