package com.gct.diagnose.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 
 * </p>
 *
 * @author xusirui
 * @since 2021-04-13
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="DgnsGtstandard对象", description="")
public class DgnsGtstandard extends Model<DgnsGtstandard> {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "生产时间")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss" , timezone = "GMT+8")
    private LocalDateTime sgtprodate;

    @ApiModelProperty(value = "id")
    @TableId(type = IdType.ASSIGN_UUID)
    private String id;

    @ApiModelProperty(value = "特征值")
    private String sgtcharacters;

    @ApiModelProperty(value = "出现次数")
    private Integer appearcounter;

    @ApiModelProperty(value = "特征解释（工况类型）")
    private String graphicfeatureinterpretation;

    @ApiModelProperty(value = "最大相似度")
    private Double maxsemblance;

    @ApiModelProperty(value = "最小相似度")
    private Double minsemblance;

    @ApiModelProperty(value = "井名称")
    private String wellname;

    @ApiModelProperty(value = "创建时间")
    private LocalDateTime createtime;

    @ApiModelProperty(value = "更新时间")
    private LocalDateTime latestupdatedtime;

    @ApiModelProperty(value = "所属组织id")
    private String orgId;

    @ApiModelProperty(value = "井ID")
    private String wellId;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    @Override
    public boolean equals(final Object obj) {
        if (obj == null) {
            return false;
        }
        return obj instanceof DgnsGtstandard && this.id.equals(((DgnsGtstandard) obj).getId());
    }

    @Override
    public int hashCode() {
        int hashno = 7;
        hashno = 13 * hashno + (id == null ? 0 : id.hashCode());
        return hashno;
    }


}
