package com.gct.diagnose.entity;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * <p>计算的标准功图入参</p>
 * @author: NewMeanning
 * @create: 2021-02-01 16:26
 **/
@Data
@AllArgsConstructor
@NoArgsConstructor
public abstract class ParamForCalDgnsGtstandard {

    /**
     * 已存在的标准功图数据集合
     */
    List<DgnsGtstandard> existedDataList;
    /**
     * 标准功图设置项（允许个数、最小相似度匹配）
     */
    DgnsGtstandardSetting dgnsGtstandardSetting;
    /**
     * 示功图
     */
    List<List<Double>> sgtList;

    /**
     * 提取功图
     * @return
     */
    public List<List<Double>> get(){
        return this.getSgtList();
    }

    /**
     * 添加标准功图库操作
     */
    public abstract void add();

    /**
     * 修改已有功图
     */
    public abstract void update(DgnsGtstandard dgnsGtstandard,Double similarityNum);

    /**
     * 获取功图与该功图的相似度
     * @param sgtList
     * @param dgnsGtstandard
     * @return
     */
    public abstract Double getSimilarityNum(List<List<Double>> sgtList,DgnsGtstandard dgnsGtstandard);

    /**
     * 删除对应标准功图
     * @param dgnsGtstandard
     */
    public abstract void remove(DgnsGtstandard dgnsGtstandard);
}

