package com.gct.diagnose.feignclient;

import com.gct.common.core.result.Result;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;

/**
 * class name: BaseDataClient
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/1/25 下午6:02
 */
@FeignClient(value = "centralbase",fallback = BaseDataHystrix.class/*,url = "${feign.addr}"*/)
public interface BaseDataClient {
    @RequestMapping(value = "/getLatestA2DailyData/{WellID}",method = RequestMethod.GET)
    String getLatestA2DailyData(@PathVariable("WellID") String wellID) ;

    @RequestMapping(value = "/WellSeriesInfo/WellSeriesInfo",method = RequestMethod.GET)
    String getWellSeriesInfo();


    @RequestMapping(value = "/WellSource/jh",method = RequestMethod.GET)
    String getjh(@RequestParam(value = "orgid",required = false)String orgid) ;

    @RequestMapping(value = "/cbPcProWellboreStatusDaily/wellBoreStatusDaily/{wellId}/{prodDate}",method = RequestMethod.GET)
    String getWellBoreStatusDaily(@PathVariable(value = "wellId")String wellId,@PathVariable(value = "prodDate")String prodDate);

    @RequestMapping(value = "/cbPcProWellboreVolDaily/wellBoreVolDaily/{wellId}/{prodDate})",method = RequestMethod.GET)
    String getWellBoreVolDaily(@PathVariable(value = "wellId")String wellId,@PathVariable(value = "prodDate")String prodDate);

    @RequestMapping("/org/getAllOrgs")
    String getAllOrganizations();

    @RequestMapping("/org/getOrgId/{orgId}")
    String getOrgId(@PathVariable("orgId") String orgId);

    @RequestMapping("/org/getOrgById/{id}")
    String getOrgById(@PathVariable("id") String id);

    @GetMapping("/org/org")
    String getOrganization(@RequestParam String parent_id);

    @GetMapping("/WellSource/getWellSource")
    public String getWellSource(@RequestParam String wellId);

    @GetMapping("/cbTempWellMechRuntime/getAllRuntimeData")
    public String getAllRuntimeData();
}
