package com.gct.diagnose.rocketmq;

import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.AllArgsConstructor;
import lombok.Data;

/**
 * class name: MQDiagnoseMsg
 * <p>
 * rocketMQ exchange message entity:
 * for diagnose process
 * <p>
 * Notice:
 * 1.the message key:well_id
 * 2.the formatter of sgt eg:0,123,1,253...
 * 3.use the secret "DiagnoseMsg_v1.0" to send message
 * 4.in order to send message sequence orderly,please do that :
 * sendOneWayOrderly(./././)
 * </p>
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/6/24 下午6:48
 */
@Data
@AllArgsConstructor
public class DiagnoseMsg implements MessageBody {
    private String wellId;
    private String wellName;
    private String orgId;

    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss" , timezone = "GMT+8")
    private String prodDate;
    private String sgt;
    private String rcvDate;
    private double s;
    private double n;

    @Override
    public String toJsonBody() {
        return JSONObject.toJSONString(this);
    }
}
