package com.gct.diagnose.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gct.diagnose.entity.DgnsGtbaseparam;
import com.gct.diagnose.mapper.DgnsGtbaseparamMapper;
import com.gct.diagnose.service.DgnsGtbaseparamService;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xusirui
 * @since 2021-04-13
 */
@Service
public class DgnsGtbaseparamServiceImpl extends ServiceImpl<DgnsGtbaseparamMapper, DgnsGtbaseparam> implements DgnsGtbaseparamService {

    @Override
    public DgnsGtbaseparam getById(String id) {
        return baseMapper.getById(id);
    }

    @Override
    public DgnsGtbaseparam getByWellName(String wellName) {
        return baseMapper.getByWellName(wellName);
    }

    @Override
    public DgnsGtbaseparam getByWellIdAndProdDate(String wellId, String prodDate) {
        return baseMapper.selectOne(new QueryWrapper<DgnsGtbaseparam>().eq("well_id",wellId).
                eq("prod_date", LocalDateTime.parse(prodDate, DateTimeFormatter.ISO_DATE_TIME)));
    }

    @Override
    public List<DgnsGtbaseparam> getNearlyOneHour(){
        return baseMapper.getNearlyOneHour();
    }

    @Override
    @Async
    public void asyncAddGtbaseparam(DgnsGtbaseparam dgnsGtbaseparam) {
        QueryWrapper<DgnsGtbaseparam> wrapper = new QueryWrapper<DgnsGtbaseparam>().
                eq("prod_date", dgnsGtbaseparam.getProdDate()).
                eq("well_id", dgnsGtbaseparam.getWellId());
        DgnsGtbaseparam one = baseMapper.selectOne(wrapper);
        if (one==null) baseMapper.insert(dgnsGtbaseparam);
        else baseMapper.update(dgnsGtbaseparam,wrapper);
    }
}
