package com.gct.diagnose.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gct.common.core.result.Result;
import com.gct.common.util.SGTUtil;
import com.gct.diagnose.entity.DgnsGtfeatures;
import com.gct.diagnose.feignclient.BaseDataClient;
import com.gct.diagnose.mapper.DgnsGtfeaturesMapper;
import com.gct.diagnose.service.DgnsGtfeaturesService;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author wsy
 * @since 2021-1-27
 */
@Service

public class DgnsGtfeaturesServiceImpl extends ServiceImpl<DgnsGtfeaturesMapper, DgnsGtfeatures> implements DgnsGtfeaturesService {

    @Autowired
    private BaseDataClient baseDataClient;


    /**
     * 分页查询特征库
     * @param pageNum
     * @param pageSize
     * @param effect_area
     * @param graphic_feature_interpretation
     * @param orgid
     * @param jh
     * @return
     */
    @Override
    public Map<String, Object>  findFeaturesByPages(Integer pageNum, Integer pageSize, Integer effect_area, String graphic_feature_interpretation, String orgid, String jh) {
        Map<String, Object> mapList= new HashMap<>();
        if(jh !=null && !"".equals(jh)){
            List<String> list1 = new ArrayList<>();
            list1.add(jh);
            List<DgnsGtfeatures> list =  baseMapper.findFeaturesByPages(pageNum-1,pageSize,list1,effect_area,graphic_feature_interpretation);
            for (DgnsGtfeatures gtfeatures : list) {
                List<List<Double>> list2 = SGTUtil.encodeToUseList(gtfeatures.getSgt());
                list2.add(0,list2.get(list2.size()-1));
                gtfeatures.setSgt(list2.toString());
            }
            mapList.put("data",list);
            int total= baseMapper.getTotal(list1,effect_area,graphic_feature_interpretation);
            mapList.put("total",total);
            mapList.put("page",pageNum-1);
            mapList.put("size",pageSize);
        }else{
            Result jh2 = JSONObject.parseObject(baseDataClient.getjh(orgid), Result.class);
            List<Map<String, Object>> list = JSONObject.parseObject(jh2.getData().toString(), List.class);

            List<Object> stringList = new ArrayList<>();
            for (Map<String, Object> stringObjectMap : list) {
                stringList.add(stringObjectMap.get("id"));
            }
            List<DgnsGtfeatures> pages = baseMapper.findFeaturesByPages(pageNum-1, pageSize, stringList, effect_area, graphic_feature_interpretation);
            for (DgnsGtfeatures page : pages) {
                List<List<Double>> list2 = SGTUtil.encodeToUseList(page.getSgt());
                list2.add(0,list2.get(list2.size()-1));
                page.setSgt(list2.toString());
            }
            int total= baseMapper.getTotal(stringList,effect_area,graphic_feature_interpretation);
            mapList.put("data",pages);
            mapList.put("total",total);
            mapList.put("page",pageNum-1);
            mapList.put("size",pageSize);
        }
        return mapList;
    }

    @Override
    public List<DgnsGtfeatures> workingConditionManagement() {
        return baseMapper.selectByMap(null);
    }

    @Override
    public Page<Map<String, Object>> getInfoByIDPages(String id, Integer page, Integer size) {
        QueryWrapper<DgnsGtfeatures> wrapper = new QueryWrapper<>();
        wrapper.eq("id",id.trim());
        Page<Map<String, Object>> mapPage = baseMapper.selectMapsPage(new Page<Map<String, Object>>(page,size), wrapper);
        for (Map<String, Object> record : mapPage.getRecords()) {
            record.put("sgt",SGTUtil.encodeToUseList(record.get("sgt").toString()));
        }
        return  mapPage;
    }


}
