package com.gct.diagnose.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gct.common.core.result.Result;
import com.gct.diagnose.entity.DgnsGtcardLib;
import com.gct.diagnose.entity.DgnsGtgktype;
import com.gct.diagnose.mapper.DgnsGtgktypeMapper;
import com.gct.diagnose.service.DgnsGtcardLibService;
import com.gct.diagnose.service.DgnsGtgktypeService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author xsr
 * @since 2021-04-26
 */
@Service
public class DgnsGtgktypeServiceImpl extends ServiceImpl<DgnsGtgktypeMapper, DgnsGtgktype> implements DgnsGtgktypeService {

    @Autowired
    public DgnsGtcardLibService dgnsGtcardLibService;

    @Override
    public JSONObject getAllGtCardLibCount(Integer curPage, Integer pageSize) {
        Page<Map<String, Object>> page = baseMapper.getAllGtCardLib(new Page<>(curPage, pageSize));
        JSONObject res = new JSONObject();
        res.put("total", page.getTotal());
        res.put("data", page.getRecords());
        return res;
    }


    @Override
    public boolean addGtGkType(DgnsGtgktype dgnsGtgktype) {
        DgnsGtgktype type = baseMapper.selectOne(
                new QueryWrapper<DgnsGtgktype>()
                        .eq("gk_name", dgnsGtgktype.getGkName()));
        if (type != null) return false;
        baseMapper.insert(dgnsGtgktype); //自增给默认值
        return true;
    }

    @Override
    @Transactional
    public boolean deleteGtGkType(Integer id) {
        baseMapper.delete(new QueryWrapper<DgnsGtgktype>().eq("id", id));
        dgnsGtcardLibService.remove(new QueryWrapper<DgnsGtcardLib>().eq("code", id));
        return true;
    }

    @Override
    @Transactional
    public boolean updateGtGkType(DgnsGtgktype dgnsGtgktype) {
        DgnsGtgktype type = baseMapper.selectOne(
                new QueryWrapper<DgnsGtgktype>()
                        .eq("gk_name", dgnsGtgktype.getGkName()));
        if (type != null) return false;
        baseMapper.updateById(dgnsGtgktype);
        return true;
    }

    @Override
    public DgnsGtgktype getGtGkTypeById(Integer id) {
        return baseMapper.selectOne(new QueryWrapper<DgnsGtgktype>().eq("id", id));
    }

    @Override
    public Result findGtgktype() {
        QueryWrapper<DgnsGtgktype> queryWrapper = new QueryWrapper<>();
        QueryWrapper<DgnsGtgktype> wrapper = queryWrapper.select(
                "id",
                "gk_name");
        List<Map<String, Object>> maps = baseMapper.selectMaps(wrapper);
        HashMap<String, Object> allMap = new HashMap<>();
        allMap.put("gk_name","全部");
        allMap.put("id","");
        maps.add(0,allMap);
        return Result.ok(maps);
    }
}
