package com.gct.diagnose.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gct.diagnose.entity.DgnsGtmloutcode;
import com.gct.diagnose.mapper.DgnsGtmloutcodeMapper;
import com.gct.diagnose.service.DgnsGtmloutcodeService;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.CachePut;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author NewMeanning
 * @since 2021-03-04
 */
@Service
public class DgnsGtmloutcodeServiceImpl extends ServiceImpl<DgnsGtmloutcodeMapper, DgnsGtmloutcode> implements DgnsGtmloutcodeService {


    @Override
    @Cacheable(value = "GK", key = "#gkcode")
    public DgnsGtmloutcode getByCode(Integer gkcode) {
        QueryWrapper<DgnsGtmloutcode> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("gkcode",gkcode);
        return this.getOne(queryWrapper);
    }

    @Override
    @CachePut(value = "GK", key = "#dgnsGtmloutcode.gkcode")
    public boolean updateByCode(DgnsGtmloutcode dgnsGtmloutcode) {
        QueryWrapper<DgnsGtmloutcode> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("gkcode",dgnsGtmloutcode.getGkcode());
        return this.update(dgnsGtmloutcode,queryWrapper);
    }

    @Override
    @CacheEvict(value = "GK", key = "#gkcode")
    public boolean deleteByCode(Integer gkcode) {
        QueryWrapper<DgnsGtmloutcode> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("gkcode",gkcode);
        return this.remove(queryWrapper);
    }

    @Override
    @CachePut(value = "GK", key = "#dgnsGtmloutcode.gkcode")
    public boolean insertGkCode(DgnsGtmloutcode dgnsGtmloutcode) {
        return this.save(dgnsGtmloutcode);
    }
}
