package com.gct.diagnose.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gct.common.core.result.Result;
import com.gct.common.util.SGTUtil;
import com.gct.diagnose.entity.DgnsGtstandard;
import com.gct.diagnose.entity.DgnsGtstandardSetting;
import com.gct.diagnose.entity.Vo.GstStandarSettingVo;
import com.gct.diagnose.feignclient.BaseDataClient;
import com.gct.diagnose.mapper.DgnsGtstandardMapper;
import com.gct.diagnose.mapper.DgnsGtstandardSettingMapper;
import com.gct.diagnose.service.DgnsGtstandardSettingService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.annotation.CachePut;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author NewMeanning
 * @since 2021-02-03
 */
@Service
public class DgnsGtstandardSettingServiceImpl extends ServiceImpl<DgnsGtstandardSettingMapper, DgnsGtstandardSetting> implements DgnsGtstandardSettingService {

    @Autowired
    DgnsGtstandardMapper dgnsGtstandardMapper;
    @Autowired
    private BaseDataClient baseDataClient;
    @Override
    @CachePut(value = "StandardSetting", key = "'1'")
    public Result setting(DgnsGtstandardSetting dgnsGtstandardSetting) {
        boolean saveOrUpdate = this.saveOrUpdate(dgnsGtstandardSetting);
        return saveOrUpdate?Result.ok(null):Result.error("设置失败，请重试");
    }

    @Override
    @Cacheable(value = "StandardSetting", key = "'1'")
    public Result getSettingInfo() {
        return Result.ok(this.getById("1"));
    }

    @Override
    @Cacheable(value = "StandardSetting", key = "'1'")
    public DgnsGtstandardSetting getSetting() {
        return this.getById("1");
    }

    @Override
    public Map<String, Object> getGtstandardSettingInfoPages(GstStandarSettingVo gstStandarSettingVo) {
        Map<String, Object> mapList= new HashMap<>();
        /*Page<Map<String,Object>> page = new Page<>();
        page.setPages(gstStandarSettingVo.getPage()-1);
        page.setSize(gstStandarSettingVo.getSize());*/
        Result result = JSONObject.parseObject(baseDataClient.getOrgId(gstStandarSettingVo.getOrgId()),Result.class);
        List<Map<String, Object>> list = JSONObject.parseObject(result.getData().toString(),List.class);
        List stringList = new ArrayList();
        for (Map<String, Object> map : list) {
            stringList.add(map.get("orgId"));
        }
        List<DgnsGtstandard> data = dgnsGtstandardMapper.getGtstandardSettingInfoPages(gstStandarSettingVo.getPage()-1, gstStandarSettingVo.getSize(), gstStandarSettingVo.getWellId(),stringList, gstStandarSettingVo.getFeatureType());
        for (DgnsGtstandard datum : data) {
            List<List<Double>> doubles = SGTUtil.encodeToUseList(datum.getSgtcharacters());
            doubles.add(0,doubles.get(doubles.size()-1));
            datum.setSgtcharacters(doubles.toString());
            //datum.setSgt(SGTUtil.encodeToUseArray(datum.getSgtcharacters()));
        }
        int total = dgnsGtstandardMapper.getTotal(gstStandarSettingVo.getWellId(), stringList, gstStandarSettingVo.getFeatureType());
        mapList.put("data",data);
        mapList.put("page",gstStandarSettingVo.getPage()-1);
        mapList.put("size",gstStandarSettingVo.getSize());
        mapList.put("total",total);
        return mapList;
    }

    @Override
    public Page<Map<String, Object>> getInfoByIDPages(String id, Integer page, Integer size) {
        QueryWrapper<DgnsGtstandard> wrapper = new QueryWrapper();
        wrapper.eq("id",id.trim());
        Page<Map<String, Object>> mapPage = dgnsGtstandardMapper.selectMapsPage(new Page(page,size), wrapper);
        for (Map<String, Object> record : mapPage.getRecords()) {
            record.put("sgtcharacters",SGTUtil.encodeToUseList(record.get("sgtcharacters").toString()));
        }
        return  mapPage;
    }
}
