package com.gct.diagnose.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.gct.diagnose.entity.DgnsGtcvrresult;
import com.gct.diagnose.entity.DgnsGtstandard;
import com.gct.diagnose.rocketmq.DiagnoseMsg;
import com.gct.diagnose.service.DiagnosticProcessService;
import com.gct.diagnose.service.impl.core.*;
import lombok.extern.slf4j.Slf4j;
import org.apache.rocketmq.spring.annotation.ConsumeMode;
import org.apache.rocketmq.spring.annotation.RocketMQMessageListener;
import org.apache.tomcat.jni.Time;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author xusirui 2021/6/29
 */

@Slf4j
@Service
@RocketMQMessageListener(
        nameServer = "${gct.rocketmq.one.name-server}",
        topic = "${gct.rocketmq.one.topic}",
        consumerGroup = "${gct.rocketmq.one.consumer.group}",
        consumeMode = ConsumeMode.ORDERLY //保证同一队列顺序消费
        , secretKey = "${gct.rocketmq.one.consumer.secret-key}"
        , accessKey = "${gct.rocketmq.one.consumer.access-key}"
)
public class DiagnosticProcess implements DiagnosticProcessService {

    @Autowired
    GenerateResult generateResult;

    @Autowired
    FirstDgns firstDgns;

    @Autowired
    GtAnalysis gtAnalysis;

    @Autowired
    SecondDgns secondDgns;

    private static int count = 0;

    @Override
    public void onMessage(String s) {
        System.out.println("count = "+count++);
        Visitor visitor = new Visitor(){
            {
                logBuilder = new StringBuilder();
                diagnoseMsg = JSONObject.parseObject(s, DiagnoseMsg.class);
                cvResult = new DgnsGtcvrresult();
                standardGt = new DgnsGtstandard();
            }
        };
        long st = System.currentTimeMillis();
        gtAnalysis.accept(visitor);
        long e1 = System.currentTimeMillis();
        firstDgns.accept(visitor);
        long e2 = System.currentTimeMillis();
        secondDgns.accept(visitor);
        long e3 = System.currentTimeMillis();
        generateResult.accept(visitor);
        long e4 = System.currentTimeMillis();
        System.out.println("step1: "+(e1-st)+" ms step2: "+(e2-e1)+
                        " ms step3: "+(e3-e2)+" ms step4: "+(e4-e3)+" ms"
                );
    }
}
