package com.gct.diagnose.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gct.common.core.result.Result;
import com.gct.common.util.SGTUtil;
import com.gct.diagnose.algorithm.DiagramValidate;
import com.gct.diagnose.decisiontree.DecisionTree;
import com.gct.diagnose.decisiontree.DecisionTreeGenerator;
import com.gct.diagnose.decisiontree.DependentDataFieldEnum;
import com.gct.diagnose.decisiontree.TemplateConfiguration;
import com.gct.diagnose.entity.*;
import com.gct.diagnose.feignclient.BaseDataClient;
import com.gct.diagnose.rocketmq.DiagnoseMsg;
import com.gct.diagnose.rocketmq.MessageProducer;
import com.gct.diagnose.rocketmq.WarnMessageProducer;
import com.gct.diagnose.service.*;
import com.gct.diagnose.thriftclient.GTComputerViewRecognitionClient;
import com.gct.diagnose.thriftclient.ThriftClientResponseData;
import lombok.extern.slf4j.Slf4j;
import org.apache.rocketmq.spring.annotation.ConsumeMode;
import org.apache.rocketmq.spring.annotation.RocketMQMessageListener;
import org.apache.rocketmq.spring.core.RocketMQTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;

/**
 * @author: NewMeanning
 * @create: 2021-02-24 18:36
 **/
@Slf4j
//@Service
/*@RocketMQMessageListener(
        nameServer = "${gct.rocketmq.one.name-server}",
        topic = "${gct.rocketmq.one.topic}",
        consumerGroup = "${gct.rocketmq.one.consumer.group}",
        consumeMode = ConsumeMode.ORDERLY //保证同一队列顺序消费
        , secretKey = "${gct.rocketmq.one.consumer.secret-key}"
        , accessKey = "${gct.rocketmq.one.consumer.access-key}"
)*/
@Deprecated
public class DiagnosticProcessServiceImpl implements DiagnosticProcessService {

    @Autowired
    private GTComputerViewRecognitionClient gtComputerViewRecognitionClient;

    @Autowired
    private DgnsGtstandardService dgnsGtstandardService;

    @Autowired
    DgnsGtcvrparamService dgnsGtcvrparamService;

    @Autowired
    DgnsGtcvrresultService dgnsGtcvrresultService;

    @Autowired
    DgnsGtcardLibService dgnsGtcardLibService;

    @Autowired
    DgnsGtbaseparamService dgnsGtbaseparamService;

    @Autowired
    DgnsGtmloutcodeService dgnsGtmloutcodeService;
    /* private AtomicInteger atomicInteger = new AtomicInteger(0);*/
    @Autowired
    DgnsGtgktypeService dgnsGtgktypeService;

    @Autowired
    BaseDataClient baseDataClient;

    @Resource(name = "warnMessageProducer")
    MessageProducer producer;

    @Override
    public void onMessage(String s) {
        try {
            DecisionTreeGenerator generator = TemplateConfiguration.getApplicationContext().getBean(DecisionTreeGenerator.class);
            log.info("{}--接收到的消息：{}", Thread.currentThread().getName(), s);
            DiagnoseMsg msg = JSONObject.parseObject(s, DiagnoseMsg.class);

            DgnsGtbaseparam dgnsGtbaseparam = new DgnsGtbaseparam();
            dgnsGtbaseparam.setSPre(msg.getS());
            dgnsGtbaseparam.setN(msg.getN());
            dgnsGtbaseparam.setProdDate(LocalDateTime.parse(msg.getProdDate(), DateTimeFormatter.ISO_DATE_TIME));
            dgnsGtbaseparam.setWellId(msg.getWellId());
            dgnsGtbaseparam.setWellname(msg.getWellName());
            dgnsGtbaseparam.setSgt(msg.getSgt());
            
            new DiagramValidate().analysisParam(SGTUtil.encodeToUseArray(msg.getSgt()), dgnsGtbaseparam);
            dgnsGtbaseparamService.asyncAddGtbaseparam(dgnsGtbaseparam);

            //转换数据
            List<List<Double>> sgtList = SGTUtil.encodeToUseList(msg.getSgt());
            //调用一次诊断
            ThriftClientResponseData<Integer> integerThriftClientResponseData
                    = gtComputerViewRecognitionClient.tryGTPredictType(sgtList, sgtList.size());
            if (!integerThriftClientResponseData.isSuccess()) {
                log.error("Thrift调用失败");
                throw new RuntimeException();
            }
            //将此处异步执行改为后台定时每隔1小时执行
            /*dgnsGtstandardService.executeAsyncTask(sgtObject, sgtList, integerThriftClientResponseData.getData());*/
            List<DgnsGtstandard> dgnsGtstandardList = dgnsGtstandardService.
                    getNearlyMostAppearCounter(msg.getWellId(), msg.getProdDate());

            //no standard Gt, diagnose failed
            if (dgnsGtstandardList == null || dgnsGtstandardList.size() == 0) {
                //todo:
                log.error("缺失标准功图 无法诊断");
                throw new RuntimeException();
            }
            Double similar = 0.0;
            DgnsGtstandard maxSimilarDgns = dgnsGtstandardList.get(0);
            for (DgnsGtstandard dgnsGtstandard : dgnsGtstandardList) {
                List<List<Double>> tmpList = SGTUtil.encodeToUseList(dgnsGtstandard.getSgtcharacters());
                ThriftClientResponseData<Double> doubleThriftClientResponseData =
                        gtComputerViewRecognitionClient.trySGTSimilarByGrayVal(tmpList, tmpList.size(), sgtList, sgtList.size());
                if (doubleThriftClientResponseData.getData() > similar) {
                    similar = doubleThriftClientResponseData.getData();
                    maxSimilarDgns = dgnsGtstandard;
                }
            }

            DgnsGtmloutcode gtmloutcode = dgnsGtmloutcodeService.getOne(new QueryWrapper<DgnsGtmloutcode>().eq("mlcode", integerThriftClientResponseData.getData()));
            DgnsGtcvrparam gtcvrparam = dgnsGtcvrparamService.getOne(new QueryWrapper<DgnsGtcvrparam>().eq("paramid", gtmloutcode==null?null:gtmloutcode.getGkcode()));

            Map<String, Object> initMap = new HashMap<>();
            initMap.put(DependentDataFieldEnum.JH.getEnDec(), msg.getWellId());
            initMap.put("orgId", msg.getOrgId());
            initMap.put("curGtTime", msg.getProdDate());
            initMap.put(DependentDataFieldEnum.BZSJ.getEnDec(), maxSimilarDgns.getSgtprodate());
            initMap.put(DependentDataFieldEnum.XSD.getEnDec(), similar);
            initMap.put("dgnsGtbaseparam", dgnsGtbaseparam);
            DecisionTree tree = null;
            if (gtcvrparam != null) tree = generator.generateDecisionTreeFromJson(gtcvrparam.getParamcontent());
            Object res = generator.setArgs(initMap).runDecisionTree(tree);
            //save result
            DgnsGtcvrresult dgnsGtcvrresult = new DgnsGtcvrresult();
            dgnsGtcvrresult.setId(UUID.randomUUID().toString());
            dgnsGtcvrresult.setResult1(integerThriftClientResponseData.getData().toString());
            if (res == null ){//缺失二次诊断算法
                dgnsGtcvrresult.setResult2(gtmloutcode==null?"工况缺失":gtmloutcode.getGkdec());
            }else {
                dgnsGtcvrresult.setResult2(res.toString());
            }
            // dgnsGtcvrresult.setWellname(sgtObject.get("well_name").toString());
            dgnsGtcvrresult.setWellId(msg.getWellId());
            dgnsGtcvrresult.setSgt(SGTUtil.encodeToUseList(msg.getSgt()).toString());
            initMap.put("BZGK", maxSimilarDgns.getGraphicfeatureinterpretation());
            dgnsGtcvrresult.setProcessparam(
                    getProcessParam(generator, integerThriftClientResponseData.getData().toString(), initMap));
            dgnsGtcvrresult.setProdDateTime(LocalDateTime.parse(msg.getProdDate().substring(0, 19), DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss")));

            dgnsGtcvrresultService.asyncAddCvrresult(dgnsGtcvrresult);
            // res id, wellname prodate orgid,
            JSONObject wnMsg = new JSONObject();
            wnMsg.put("wellId", msg.getWellId());
            wnMsg.put("context", dgnsGtcvrresult.getResult2());
            wnMsg.put("wnDate", LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss")));
            wnMsg.put("resultId", dgnsGtcvrresult.getId());

            sendMessage(wnMsg, dgnsGtcvrresult);
            
        } catch (Exception e) {
            if (e.getMessage() != null && e.getMessage().equals("最后一个节点必须为逻辑运算结果")) {
                log.error("缺少基础数据 诊断失败");
                e.printStackTrace();
            } else {
                log.error("诊断失败");
                e.printStackTrace();
                throw new RuntimeException();
            }

        }
    }

    private void generatorErrorResult() {
    }


    String getProcessParam(DecisionTreeGenerator generator, String result, Map initMap) {
        Map<String, String> processparam = new HashMap<>();
        processparam.put("SJ", initMap.get("curGtTime").toString());
        //传入井名字给前端，JH代表 name，wellname代表 id
        processparam.put(DependentDataFieldEnum.JH.getEnDec(),
                getCommonName(generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.JH.getEnDec()).toString()));
        processparam.put(DependentDataFieldEnum.BS.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.BS.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.BZBS.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.BZBS.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.BJ.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.BJ.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.BZBJ.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.BZBJ.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.CC.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.CC.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.BZCC.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.BZCC.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.CCi.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.CCi.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.BZCCi.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.BZCCi.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.ZDZH.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.ZDZH.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.BZZDZH.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.BZZDZH.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.ZXZH.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.ZXZH.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.BZZXZH.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.BZZXZH.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.RCYe.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.RCYe.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.BZRCYe.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.BZRCYe.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.RCY.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.RCY.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.BZRCY.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.BZRCY.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.HSL.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.HSL.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.BZHSL.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.BZHSL.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.DYM.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.DYM.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.BZDYM.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.BZDYM.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.CMD.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.CMD.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.BZCMD.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.BZCMD.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.LOG.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.LOG.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.BZGT.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.BZGT.getEnDec()).toString());
        processparam.put(DependentDataFieldEnum.BZSJ.getEnDec(),
                generator.getGlobeData().getGlobeDataValue(DependentDataFieldEnum.BZSJ.getEnDec()).toString());
        DgnsGtcardLib tzGt = dgnsGtcardLibService.list(new QueryWrapper<DgnsGtcardLib>().eq("code", Integer.parseInt(result))).get(0);

        processparam.put("TZGT", SGTUtil.encodeToUseList(tzGt.getIndicatorDiagram()).toString());
        processparam.put("TZSJ", tzGt.getProDateStr());
        processparam.put("TZJH", getCommonName(tzGt.getWellId()));
        DgnsGtmloutcode dgnsGtmloutcode = dgnsGtmloutcodeService.getOne(new QueryWrapper<DgnsGtmloutcode>().eq("gkcode", Integer.parseInt(result)));
        processparam.put("TZ", dgnsGtmloutcode.getGkdec());
        //站点 作业区 井区
        String orgId = initMap.get("orgId").toString();
        Result res = JSONObject.parseObject(baseDataClient.getOrgById(orgId), Result.class);
        JSONObject data = JSONObject.parseObject(res.getData().toString());
        processparam.put("ZD", data.getString("orgId"));
        res = JSONObject.parseObject(baseDataClient.getOrgById(data.getString("parentId")), Result.class);
        data = JSONObject.parseObject(res.getData().toString());
        processparam.put("JQ", data.getString("orgId"));
        res = JSONObject.parseObject(baseDataClient.getOrgById(data.getString("parentId")), Result.class);
        data = JSONObject.parseObject(res.getData().toString());
        processparam.put("ZYQ", data.getString("orgId"));
        //标准工况
        processparam.put("BZGK", initMap.get("BZGK").toString());
        return JSONObject.toJSONString(processparam);
    }

    @Resource
    RocketMQTemplate rocketMQTemplate;

    @Async
    void sendMessage(JSONObject wnMsg, DgnsGtcvrresult dgnsGtcvrresult) {
        //根据报警策略获取
        wnMsg.put("category", "供液异常");
        wnMsg.put("rank", "3");
        System.out.println(wnMsg);
        rocketMQTemplate.sendOneWayOrderly("wnGkMsg", wnMsg, wnMsg.getString("wellId"));

    }

    public String getCommonName(String wellId) {
        JSONObject jo = JSONObject.parseObject(JSONObject.parseObject(baseDataClient.getWellSource(wellId), Result.class).getData().toString());
        return jo.getString("wellCommonName");
    }


}


