package com.gct.diagnose.service.impl.core;

import com.gct.common.util.SGTUtil;
import com.gct.diagnose.algorithm.DiagramValidate;
import com.gct.diagnose.entity.DgnsGtbaseparam;
import com.gct.diagnose.entity.DgnsGtcvrresult;
import com.gct.diagnose.rocketmq.DiagnoseMsg;
import com.gct.diagnose.service.DgnsGtbaseparamService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

/**
 * @author xusirui 2021/6/29
 */
@Component
public class GtAnalysisImpl implements GtAnalysis{

    @Autowired
    DgnsGtbaseparamService dgnsGtbaseparamService;

    @Override
    public void accept(Visitor visitor) {
        DiagnoseMsg msg = visitor.diagnoseMsg;
        DgnsGtbaseparam dgnsGtbaseparam = new DgnsGtbaseparam();
        dgnsGtbaseparam.setSPre(msg.getS());
        dgnsGtbaseparam.setN(msg.getN());
        dgnsGtbaseparam.setProdDate(LocalDateTime.parse(msg.getProdDate(), DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss")));
        dgnsGtbaseparam.setWellId(msg.getWellId());
        dgnsGtbaseparam.setWellname(msg.getWellName());
        dgnsGtbaseparam.setSgt(msg.getSgt());
        new DiagramValidate().analysisParam(SGTUtil.encodeToUseArray(msg.getSgt()), dgnsGtbaseparam);
        dgnsGtbaseparamService.asyncAddGtbaseparam(dgnsGtbaseparam);

        if (dgnsGtbaseparam.getIslegal()==0){
            DgnsGtcvrresult result = visitor.cvResult = new DgnsGtcvrresult();
            result.setResult2(dgnsGtbaseparam.getRemark());
        }
        visitor.gtbaseparam = dgnsGtbaseparam;
    }
}
