package com.gct.diagnose.service.impl.core;

import com.gct.diagnose.entity.DgnsGtcvrresult;
import com.gct.diagnose.rocketmq.DiagnoseMsg;
import com.gct.diagnose.rocketmq.MessageProducer;
import com.gct.diagnose.rocketmq.WarnMessageProducer;
import com.gct.diagnose.rocketmq.WarnMsg;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationEvent;
import org.springframework.context.ApplicationListener;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.time.LocalDateTime;

/**
 * @author xusirui 2021/6/30
 */
@Component
public class SendWarnMessageImpl implements ApplicationListener<WarnSendEvent> {

    @Resource(name = "warnMessageProducer")
    MessageProducer warnMessageProducer;

    @Override
    public void onApplicationEvent(WarnSendEvent event) {

        DgnsGtcvrresult diagnoseMsg = (DgnsGtcvrresult) event.getSource();
        WarnMsg warnMsg = new WarnMsg(diagnoseMsg.getWellId(),
                diagnoseMsg.getResult2(),
                LocalDateTime.now().toString(),
                diagnoseMsg.getId(),
                "工况异常",
                "3"
        );
        warnMessageProducer.send(warnMsg);
    }
}
