package com.gct.diagnose;

import com.alibaba.fastjson.JSONObject;
import com.gct.common.core.result.Result;
import com.gct.diagnose.entity.Vo.GstStandarSettingVo;
import com.gct.diagnose.feignclient.BaseDataClient;
import com.gct.diagnose.mapper.DgnsGtfeaturesMapper;
import com.gct.diagnose.service.DgnsGtcvrresultService;
import com.gct.diagnose.service.DgnsGtstandardSettingService;
import com.gct.diagnose.service.DgnsGtfeaturesService;
import com.gct.diagnose.thriftclient.GTComputerViewRecognitionClient;
import com.gct.diagnose.thriftclient.ThriftClientResponseData;
import lombok.extern.slf4j.Slf4j;
//import org.junit.jupiter.api.Test;// Don't use the @Test that in the package
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

@Slf4j
@SpringBootTest(classes = DiagnoseApplication.class)
@RunWith(SpringRunner.class)
@ContextConfiguration
public class DiagnoseTest {
    @Autowired
    private GTComputerViewRecognitionClient GTComputerViewRecognitionClient;

    //测试类不能用构造函数注入
    /*@Autowired
    public DiagnosetTest(GTComputerViewRecognitionClient GTComputerViewRecognitionClient) {
        this.GTComputerViewRecognitionClient = GTComputerViewRecognitionClient;
    }*/


    @Test
    public void GTPredictType() {
        log.info("start to test");
        ThriftClientResponseData<Integer> data = GTComputerViewRecognitionClient.tryGTPredictType(null, 0);
        ThriftClientResponseData<Double> data1 = GTComputerViewRecognitionClient.trySGTSimilarByGrayVal(null, 0, null, 0);
        log.info("result:{}",data);
        log.info("result:{}",data1);

        log.info("test successfully");
    }

    /*@Autowired
   DependentDataConstructor dependentDataConstructor;*/
    @Autowired
    BaseDataClient baseDataClient;
    @Test
    public void test1(){
        String orgId = baseDataClient.getOrgId("1");
        Result result = JSONObject.parseObject(orgId,Result.class);
        System.out.println(result.getData());
    }

    @Test
    public void test() {//test error  2021.1.25 19:17
        log.info("start to test");
        String wellSeriesInfo = baseDataClient.getWellSeriesInfo();
        log.info("test successfully {}",wellSeriesInfo);


        return;
    }

  /*  @Test
    public void test2() {//test error  2021.1.25 19:17
        String orgid ="1";
        log.info("start to test");
        String JH[] = baseDataClient.getjh(orgid);
        log.info("test successfully {}",JH);


        return;
    }*/
      @Autowired
  DgnsGtfeaturesService dgns_gtfeaturesService;
      @Autowired
      DgnsGtfeaturesMapper dgns_gtfeaturesMapper;
      @Autowired
    DgnsGtstandardSettingService dgnsGtstandardSettingService;
    @Test
    public void findFeaturesByPages(){
        System.out.println(dgns_gtfeaturesService.findFeaturesByPages(0, 8, 1, null, "14", ""));
       // List list1 = new ArrayList();
       // list1.add("H257");
       // dgns_gtfeaturesMapper.gett(list1);
        GstStandarSettingVo standarSettingVo = new GstStandarSettingVo();
        standarSettingVo.setPage(1);
        standarSettingVo.setSize(10);
        standarSettingVo.setOrgId("1");
        standarSettingVo.setFeatureType("供液不足");
        standarSettingVo.setWellId("测H001");
        System.out.println(dgnsGtstandardSettingService.getGtstandardSettingInfoPages(standarSettingVo));
    }
    @Test
    public void test11(){
        dgnsGtstandardSettingService.getInfoByIDPages("1385175376992591874", 1, 8);
    }

    @Autowired
    DgnsGtcvrresultService dgnsGtcvrresultService;

    @Test
    public void ttest(){
        System.out.println(dgnsGtcvrresultService.saveUserConfirm("29bb8679-f9bd-4443-8580-6812710b8dc4", "杆断脱", "检查管道","[]","2020-01-20","3","admin"));

    }
}