package com.gct.diagnose.asynctest;

import com.gct.diagnose.DiagnoseApplication;
import io.netty.util.concurrent.CompleteFuture;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.context.annotation.Bean;
import org.springframework.core.task.AsyncTaskExecutor;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ExecutionException;

/**
 * class name: Test
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/6/25 下午12:40
 */
@Slf4j
@SpringBootTest(classes = DiagnoseApplication.class)
@RunWith(SpringRunner.class)
@ContextConfiguration
public class AsyncTest {
    @Test
    public void test() throws ExecutionException, InterruptedException {

        CompletableFuture<String> cf = CompletableFuture.supplyAsync(() -> {
            try {
                Thread.sleep(1000);
            } catch (InterruptedException e) {
//                e.printStackTrace();
            }
            System.out.println(",,,,,,,,,,,,,,,,,,,,");
            return "ok" + 1;
        });

        log.error("xxxxxxxxxxxxxxxxxx");
        System.out.println("cf.get() = " + cf.get());
    }

    @Autowired
    TaskTest tt ;



    @Test
    public void testAsyncAnnotation() {
        for (int i = 0; i < 100; ++i) {
            tt.run(i);
        }
    }
}
