package com.gct.diagnose.decisiontree;

import com.alibaba.fastjson.JSONObject;
import com.gct.diagnose.DiagnoseApplication;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.ArrayList;

@Slf4j
@SpringBootTest(classes = DiagnoseApplication.class)
@RunWith(SpringRunner.class)
@ContextConfiguration
public class DecisionTreeGeneratorTest {

    @Autowired
    DecisionTreeGenerator generator;

    @Test
    public void generateJsonStrEtc() {
        ArrayList<ArrayList<String>> arrayLists = new ArrayList<>();
        DecisionTree treeRoot = new DecisionTree();
        treeRoot.exeCalTemps = new String[]{"<", ">", "&&"};
        treeRoot.inArgsFigure = JSONObject.parseObject("[['@YXCC','0.3'],['@ZDZH','@BZZDZH'],['@s1','@s2']]", arrayLists.getClass());
        treeRoot.outArgsFigure = JSONObject.parseObject(" [['s1'],['s2'],[]]", arrayLists.getClass());
        DecisionTree leftNode = new DecisionTree();
        leftNode.exeCalTemps = new String[]{"-", ">", "<", "&&"};
        leftNode.inArgsFigure = JSONObject.parseObject("[['@ZHC','@BZZHC'],['@s3','5'],['@ZXZH','15'],['@s4','@s5']]", arrayLists.getClass());
        leftNode.outArgsFigure = JSONObject.parseObject("[['s3'],['s4'],['s5'],[]]", arrayLists.getClass());

        treeRoot.setLeftNode(leftNode);
        DecisionTree rightNode = new DecisionTree();
        rightNode.setFinalOutContent("No problem");
        treeRoot.setRightNode(rightNode);

        DecisionTree leftLeaf = new DecisionTree();
        leftLeaf.setFinalOutContent("Pump break");
        DecisionTree rightLeaf = new DecisionTree();
        rightLeaf.setFinalOutContent("No problem");

        leftNode.setLeftNode(leftLeaf);
        leftNode.setRightNode(rightLeaf);
        String jsonStr = JSONObject.toJSON(treeRoot).toString();
        System.out.println(jsonStr);
        DecisionTree tree=JSONObject.parseObject(jsonStr,DecisionTree.class);
        System.out.println(tree.toString());
    }
/*
    @Test
    public void test() {

        //DecisionTreeGenerator generator = new DecisionTreeGenerator();

        DecisionTree tree = generator.generateDecisionTreeFromJson(null);

        tree = new DecisionTree();
        tree.exeCalTemps = new String[]{"+", "-", "<"};
        ArrayList<ArrayList<String>> arrayLists = new ArrayList<>();
        tree.inArgsFigure = JSONObject.parseObject("[['1','2'],['1','2','@DYM'],['@s2',0]]", arrayLists.getClass());
        tree.outArgsFigure = JSONObject.parseObject("[['s1'],['s2'],[]]", arrayLists.getClass());
        DecisionTree left = new DecisionTree();
        left.setFinalOutContent("Test left");
        DecisionTree right = new DecisionTree();
        right.setFinalOutContent("Test right");
        tree.setLeftNode(left).setRightNode(right);
        try {
            Object result = generator.setArgs(null).runDecisionTree(tree);
            System.out.println("final result: " + result);
        } catch (OperationNotSupportedException e) {
            e.printStackTrace();
        }
    }*/

    @Test
    public void testSyncTemplateSettings() {
        for (Object o : TemplateConfiguration.getComputeTemplateBeans().values()) {
            ComputeTemplateProxyFactory.ComputeTemplate annotation = o.getClass().getAnnotation(ComputeTemplateProxyFactory.ComputeTemplate.class);
            String name = annotation.prefix() + annotation.name();
            String dec = annotation.describe();

            /**
             *
             * TODO:将所有的模板配置存入数据库中 need to new a table for this
             *
             */
        }
    }

    @Test
    public void testSyncGlobeDataEnum() {

        for (DependentDataFieldEnum value : DependentDataFieldEnum.values()) {
            String dec = value.getDec();
            int id = value.getTypeID();

            /**
             * TODO:将所有的可用全局读取数据配置写入到数据库中
             */
        }

    }

}