package com.gct.diagnose.rocketmq;

import lombok.extern.slf4j.Slf4j;
import org.apache.rocketmq.client.consumer.DefaultMQPushConsumer;
import org.apache.rocketmq.client.consumer.listener.ConsumeConcurrentlyContext;
import org.apache.rocketmq.client.consumer.listener.ConsumeConcurrentlyStatus;
import org.apache.rocketmq.client.consumer.listener.MessageListenerConcurrently;
import org.apache.rocketmq.client.exception.MQClientException;
import org.apache.rocketmq.common.message.MessageExt;

import java.util.List;

/**
 * @author: NewMeanning
 * @create: 2021-02-24 15:01
 **/
@Slf4j
public class ConsumerTest {
    public static void main(String[] args) throws MQClientException {
        //创建消息消费者
        DefaultMQPushConsumer consumer = new DefaultMQPushConsumer("diagnose");
        //设置NameServer
        consumer.setNamesrvAddr("101.200.219.190:9876");
        //指定订阅的主题和标签
        consumer.subscribe("Diagnose_SGT","*");
        //注册消息监听，回调函数
        consumer.registerMessageListener((MessageListenerConcurrently) (list, consumeConcurrentlyContext) -> {

            list.forEach( messageExt -> {
                System.out.println(new String(messageExt.getTopic()+messageExt.getQueueId()));
            });
            return ConsumeConcurrentlyStatus.CONSUME_SUCCESS;
        });
        //启动消费者
        consumer.start();
    }
}
