package com.gct.diagnose.rocketmq;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gct.common.core.result.Result;
import com.gct.diagnose.DiagnoseApplication;
import com.gct.diagnose.entity.DgnsGtcvrresult;
import com.gct.diagnose.feignclient.BaseDataClient;
import com.gct.diagnose.service.DgnsGtcvrresultService;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.context.annotation.Import;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import javax.annotation.Resource;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.stream.Collectors;

/**
 * class name: ProducerPro
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/6/24 下午8:07
 */
@Slf4j
@SpringBootTest(classes = DiagnoseApplication.class)
@RunWith(SpringRunner.class)
@Import(GCTRocketMQConfiguration.class)
@ContextConfiguration
public class ProducerPro {

    @Resource(name = "diagnoseMessageProducer")
    private MessageProducer producer;

    @Autowired
    BaseDataClient baseDataClient;

    @Test
    public void testMsgProducer() {
        String allRuntimeData = baseDataClient.getAllRuntimeData();
        Result result = JSONObject.parseObject(allRuntimeData, Result.class);
        Object data = result.getData();
        JSONArray jsonArray = JSONArray.parseArray(data.toString());
        int count = 0;
        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jo = jsonArray.getJSONObject(i);
            String wellId = jo.getString("wellId");
            String sourceStr = baseDataClient.getWellSource(wellId);
            Result res = JSONObject.parseObject(sourceStr, Result.class);
            if (res.getData() == null) {
                System.out.println(wellId);
            } else {
                count++;
                JSONObject wellSource = JSONObject.parseObject(res.getData().toString());
                String wellName = wellSource.getString("wellCommonName");
                String orgId = wellSource.getString("orgId");
                String prodDate = jo.getString("prodDate");
                Integer strokeLength = jo.getInteger("strokeLength");
                Integer strokeFrequency = jo.getInteger("strokeFrequency");
                String sgt = jo.getString("sgt");
                DiagnoseMsg diagnoseMsg = new DiagnoseMsg(wellId, wellName, orgId, prodDate, sgt, LocalDateTime.now().toString(), strokeLength, strokeFrequency);
                producer.send(diagnoseMsg);
            }
        }
    }

    @Autowired
    DgnsGtcvrresultService dgnsGtcvrresultService;

    @Test
    public void sendAoidMsg() {
        List<DgnsGtcvrresult> list = dgnsGtcvrresultService.list();
        list = list.stream().filter(x -> Integer.parseInt(x.getResult1()) > 0).collect(Collectors.toList());
    }


}
