package com.gct.diagnose.rocketmq;


import com.alibaba.fastjson.JSONObject;
import com.gct.diagnose.DiagnoseApplication;
import com.gct.diagnose.entity.DgnsGtmeasureInfo;
import com.gct.diagnose.feignclient.BaseDataClient;
import com.gct.diagnose.service.DgnsGtcvrresultService;
import com.gct.diagnose.service.DgnsGtgktypeService;
import com.gct.diagnose.service.DgnsGtmeasureInfoService;
import com.gct.diagnose.service.impl.DiagnosticProcessServiceImpl;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.rocketmq.client.exception.MQClientException;
import org.apache.rocketmq.client.producer.DefaultMQProducer;
import org.apache.rocketmq.common.message.Message;
import org.apache.rocketmq.remoting.common.RemotingHelper;
import org.apache.rocketmq.remoting.exception.RemotingException;
import org.apache.rocketmq.spring.core.RocketMQTemplate;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import javax.annotation.Resource;
import java.io.UnsupportedEncodingException;
import java.nio.charset.StandardCharsets;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

/**
 * @author: NewMeanning
 * @create: 2021-02-24 10:14
 **/
@Slf4j
@SpringBootTest(classes = DiagnoseApplication.class)
@RunWith(SpringRunner.class)
@ContextConfiguration
public class ProducerTest {


    private DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");


   /* @Resource
    RocketMQTemplate rocketMQTemplate;*/

    @Test
    public void Test() throws UnsupportedEncodingException, RemotingException, InterruptedException, MQClientException {
        /**
         * hashKey: 为了保证报到同一个队列中，将消息发送到Diagnose_SGT主题上
         */
        Integer cnt = 0;

        JSONObject jo = new JSONObject();

      //  jo.put("well_id", "");
        jo.put("well_name", "XJ_001");
        jo.put("org_id", "14");
        jo.put("prod_date", "2021-01-25 09:00:00");
        jo.put("sgt", "0,4176,0,4208,1,4256,3,4304,6,4416,9,4496,12,4576,17,4768,21,4864,25,4912,32,4864,38,4784,43,4704,52,4560,59,4496,66,4480,73,4496,84,4608,92,4688,100,4736,112,4816,121,4816,129,4800,143,4704,152,4640,161,4592,175,4560,185,4560,194,4576,204,4592,218,4640,227,4656,237,4656,251,4640,260,4624,269,4592,283,4512,292,4480,300,4464,313,4432,321,4432,329,4448,337,4448,348,4432,355,4400,362,4368,371,4304,377,4256,383,4208,390,4128,395,4112,399,4096,405,4064,408,4064,411,4047,414,4064,416,4064,418,4047,419,4047,419,4032,419,4015,419,3968,417,3904,416,3856,414,3792,410,3600,407,3536,403,3504,399,3520,393,3584,388,3647,383,3711,374,3824,368,3808,362,3776,352,3679,345,3615,337,3568,326,3504,317,3520,309,3536,301,3584,288,3647,279,3664,270,3664,256,3647,247,3600,237,3568,223,3520,213,3504,204,3504,190,3536,180,3568,171,3600,161,3615,148,3647,139,3647,130,3632,117,3615,108,3615,100,3615,88,3632,80,3664,73,3696,63,3760,56,3792,50,3808,44,3840,35,3856,30,3856,25,3872,19,3904,15,3920,12,3952,7,4015,5,4047,3,4064,1,4096,0,4112,0,4112");
        RocketMQTemplate rocketMQTemplate = new RocketMQTemplate();
        DefaultMQProducer producer = new DefaultMQProducer("diagnose");
        producer.setNamesrvAddr("101.200.219.190:9876");
        producer.start();
        Message message = new Message();
        message.setBody(jo.toJSONString().getBytes(StandardCharsets.UTF_8));
        message.setTopic("Diagnose_SGT");
        producer.sendOneway(message);
        //rocketMQTemplate.setProducer(producer);
        //rocketMQTemplate.sendOneWayOrderly("Diagnose_SGT", jo.toJSONString(),jo.getString("well_name"));
           /* map.put("well_id","XJ_001");
            map.put("well_name","测H002");
            map.put("prod_date","2021-02-25 10:00:00");
            map.put("sgt","0,4176,0,4208,1,4256,3,4304,6,4416,9,4496,12,4576,17,4768,21,4864,25,4912,32,4864,38,4784,43,4704,52,4560,59,4496,66,4480,73,4496,84,4608,92,4688,100,4736,112,4816,121,4816,129,4800,143,4704,152,4640,161,4592,175,4560,185,4560,194,4576,204,4592,218,4640,227,4656,237,4656,251,4640,260,4624,269,4592,283,4512,292,4480,300,4464,313,4432,321,4432,329,4448,337,4448,348,4432,355,4400,362,4368,371,4304,377,4256,383,4208,390,4128,395,4112,399,4096,405,4064,408,4064,411,4047,414,4064,416,4064,418,4047,419,4047,419,4032,419,4015,419,3968,417,3904,416,3856,414,3792,410,3600,407,3536,403,3504,399,3520,393,3584,388,3647,383,3711,374,3824,368,3808,362,3776,352,3679,345,3615,337,3568,326,3504,317,3520,309,3536,301,3584,288,3647,279,3664,270,3664,256,3647,247,3600,237,3568,223,3520,213,3504,204,3504,190,3536,180,3568,171,3600,161,3615,148,3647,139,3647,130,3632,117,3615,108,3615,100,3615,88,3632,80,3664,73,3696,63,3760,56,3792,50,3808,44,3840,35,3856,30,3856,25,3872,19,3904,15,3920,12,3952,7,4015,5,4047,3,4064,1,4096,0,4112,0,4112");
            rocketMQTemplate.sendOneWayOrderly("Diagnose_SGT",map,map.get("well_name").toString());
*/
        /*            Thread.sleep(1000);*/

        /*
        map.put("well_id","XJ_002");
        map.put("well_name","测H002");
        map.put("prod_date","2021-01-25 10:00:00");
        map.put("sgt","0,2768,0,2880,1,3008,3,3168,5,3328,7,3504,9,3696,12,3840,16,3872,19,3760,23,3647,28,3647,32,3728,37,3824,43,3808,48,3744,54,3679,60,3679,66,3744,73,3792,80,3776,87,3728,94,3696,101,3696,109,3744,116,3760,124,3744,131,3711,139,3679,147,3696,157,3728,165,3728,173,3696,180,3679,188,3664,195,3679,203,3679,210,3679,217,3664,224,3647,230,3647,237,3647,243,3647,249,3647,255,3632,260,3632,265,3615,270,3615,274,3632,278,3632,282,3615,286,3615,289,3615,291,3615,294,3632,296,3632,297,3584,298,3504,299,3472,299,3456,299,3488,299,3504,298,3504,296,3472,295,3440,292,3456,290,3472,287,3472,284,3456,280,3424,276,3408,272,3408,267,3408,262,3392,257,3360,251,3328,245,3279,239,3247,233,3200,226,3152,219,3056,212,2944,205,2816,198,2656,191,2464,183,2240,175,2096,168,2160,160,2320,152,2384,142,2240,134,2144,127,2144,119,2240,111,2304,104,2304,97,2240,89,2192,82,2208,75,2272,69,2320,62,2320,56,2288,50,2272,45,2288,39,2336,34,2368,29,2368,25,2352,21,2352,17,2384,13,2416,10,2432,8,2432,5,2432,3,2416,2,2464,1,2544,0,2608,0,2656");
        rocketMQTemplate.sendOneWayOrderly("Diagnose_SGT",map,map.get("well_name").toString());
        map.put("prod_date","2021-01-26 10:00:00");
        map.put("sgt","0,2768,0,2880,1,3008,3,3168,5,3328,7,3504,9,3696,12,3840,16,3872,19,3760,23,3647,28,3647,32,3728,37,3824,43,3808,48,3744,54,3679,60,3679,66,3744,73,3792,80,3776,87,3728,94,3696,101,3696,109,3744,116,3760,124,3744,131,3711,139,3679,147,3696,157,3728,165,3728,173,3696,180,3679,188,3664,195,3679,203,3679,210,3679,217,3664,224,3647,230,3647,237,3647,243,3647,249,3647,255,3632,260,3632,265,3615,270,3615,274,3632,278,3632,282,3615,286,3615,289,3615,291,3615,294,3632,296,3632,297,3584,298,3504,299,3472,299,3456,299,3488,299,3504,298,3504,296,3472,295,3440,292,3456,290,3472,287,3472,284,3456,280,3424,276,3408,272,3408,267,3408,262,3392,257,3360,251,3328,245,3279,239,3247,233,3200,226,3152,219,3056,212,2944,205,2816,198,2656,191,2464,183,2240,175,2096,168,2160,160,2320,152,2384,142,2240,134,2144,127,2144,119,2240,111,2304,104,2304,97,2240,89,2192,82,2208,75,2272,69,2320,62,2320,56,2288,50,2272,45,2288,39,2336,34,2368,29,2368,25,2352,21,2352,17,2384,13,2416,10,2432,8,2432,5,2432,3,2416,2,2464,1,2544,0,2608,0,2656");
        rocketMQTemplate.sendOneWayOrderly("Diagnose_SGT",map,map.get("well_name").toString());*/
    }

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    class SGT {
        private String wellId;

        @ApiModelProperty(value = "采集日期")
        private LocalDateTime prodDate;

        @ApiModelProperty(value = "示功图内容")
        private String sgt;
    }

    /**
     * 手动方式发送消息
     */
    public static void main(String[] args) throws Exception {
        // Instantiate with a producer group name.
        DefaultMQProducer producer = new DefaultMQProducer("diagnose");
        // Specify name server addresses.
        producer.setNamesrvAddr("101.200.219.190:9876");
        // Launch the instance.
        producer.start();
        for (int i = 0; i < 5; i++) {
            // Create a message instance, specifying topic, tag and message body.
            Message msg = new Message("SGT" /* Topic */,
                    "TagA" /* Tag */,
                    ("Hello RocketMQ " + i).getBytes(RemotingHelper.DEFAULT_CHARSET) /* Message body */
            );
            // Call send message to deliver message to one of brokers.
            //SendResult sendResult = producer.send(msg);
            //发送单向消息
            producer.sendOneway(msg);
            System.out.println(msg);
        }
        //Shut down once the producer instance is not longer in use.
        producer.shutdown();
    }

    @Autowired
 DgnsGtmeasureInfoService dgnsGtmeasureInfoService;@Test
    public void dos() {
        System.out.println(dgnsGtmeasureInfoService.getAllMeasureInfo("14", 3, "XJ_001", "2020-01-01", "2022-01-01", null, null, null, 1, 100));
    }

    @Autowired
    BaseDataClient baseDataClient;


    @Test
    public void getOrgId() {
        dgnsGtmeasureInfoService.updateMeasureInfo(new DgnsGtmeasureInfo());
        //dgnsGtmeasureInfoService.getMeasureInfoCount("2020-01-01", "2021-12-31", "14").forEach(System.out::println);
    }

    @Autowired
    DgnsGtgktypeService dgnsGtgktypeService;

    @Autowired
    DiagnosticProcessServiceImpl diagnosticProcessService;

    @Autowired
    DgnsGtcvrresultService dgnsGtcvrresultService;

    @Test
    public void testt() {
        //System.out.println(dgnsGtcvrresultService.getCvrresultByTime("2020-01-01","2021-12-31","XJ_001",1,100));
        System.out.println(dgnsGtcvrresultService.getDgnsAlgorithm(7,"泵卡算法","0"));
    }

}
